#!/bin/bash

#################### Begin 识别primary graphics card的VendorID和DeviceID ##################
hwif="/tmp/hwif.txt"
hwinf1="/tmp/hwinfo1.txt"
hwinf2="/tmp/hwinfo2.txt"

GCARD1_PATH=""
GCARD1_VENDOR=""
GCARD1_DEVICE=""
GCARD2_PATH=""
GCARD2_VENDOR=""
GCARD2_DEVICE=""
card_vendor=""
card_id=""

rm -rf $hwif $hwinf1 $hwinf2
hwinfo --gfxcard > $hwif
CARDNUMBER=`cat $hwif | grep "SysFS ID:" | wc -l`
if [ $CARDNUMBER -eq 1 -o $CARDNUMBER -eq 2 ]; then
	#处理设备信息
	grep -E " SysFS ID: | Vendor: | Device: " $hwif > $hwinf1
	sed -i 's/^[ \t]*//g' $hwinf1 #去掉行首空格

	cat $hwinf1 | awk -F " " '{print $3}' > $hwinf2
#	while read -r line
#	do
#		echo $line | awk -F " " '{print $3}' >> $hwinf2
#	done < $hwinf1
else
	echo "Error"
	exit 0
fi
sed -i 's/0x//g' $hwinf2

FILENUMBER=`cat $hwinf2 | wc -l` #获取文件行数
if [ $CARDNUMBER -eq 1 -a $FILENUMBER -eq 3 ]; then
	GCARD1_PATH=`sed -n '1p' $hwinf2`
	GCARD1_VENDOR=`sed -n '2p' $hwinf2`
	GCARD1_DEVICE=`sed -n '3p' $hwinf2`

#	GCARD1_FILEPATH=`echo "/sys"${GCARD1_PATH}"/boot_vga"`
#	GCARD1_BOOT=`cat $GCARD1_FILEPATH`
#	if [ $GCARD1_BOOT -eq 1 ]; then
		card_vendor=$GCARD1_VENDOR
		card_id=$GCARD1_DEVICE
#	fi
fi
if [ $CARDNUMBER -eq 2 -a $FILENUMBER -eq 6 ]; then
	GCARD1_PATH=`sed -n '1p' $hwinf2`
	GCARD1_VENDOR=`sed -n '2p' $hwinf2`
	GCARD1_DEVICE=`sed -n '3p' $hwinf2`

	GCARD2_PATH=`sed -n '4p' $hwinf2`
	GCARD2_VENDOR=`sed -n '5p' $hwinf2`
	GCARD2_DEVICE=`sed -n '6p' $hwinf2`

	GCARD1_FILEPATH=`echo "/sys"${GCARD1_PATH}"/boot_vga"`
	GCARD1_BOOT=`cat $GCARD1_FILEPATH`
	GCARD2_FILEPATH=`echo "/sys"${GCARD2_PATH}"/boot_vga"`
	GCARD2_BOOT=`cat $GCARD2_FILEPATH`
	if [ $GCARD1_BOOT -eq 1 ]; then
		card_vendor=$GCARD1_VENDOR
		card_id=$GCARD1_DEVICE
	fi
	if [ $GCARD2_BOOT -eq 1 ]; then
		card_vendor=$GCARD2_VENDOR
		card_id=$GCARD2_DEVICE
	fi
fi
#################### End 识别primary graphics card的VendorID和DeviceID ##################

#if [[ `lspci -n |grep "1106:3a01"` ]];then   # 兆芯C集显
if [ $card_vendor = "1106" -a $card_id = "3a01" ]; then   #兆芯C集显
	dpkg -s xserver-xorg-video-s3g &>/dev/null || dpkg -i /usr/local/nfsdrivers/xserver-xorg-video-s3g_*_amd64.deb
	lsmod |grep s3g || modprobe s3g
#elif [[ `lspci -n |grep "1d17:3a03"` ]];then    #兆芯D集显
elif [ $card_vendor = "1d17" -a $card_id = "3a03" ]; then   #兆芯D集显
	dpkg -s zhaoxin-chx001-linux-graphics-driver &>/dev/null || dpkg -i /usr/local/nfsdrivers/zhaoxin-chx001-linux-graphics-driver*_amd64.deb
	lsmod |grep "^zx" || modprobe zx
#elif [[ `lspci -n |grep "1d17:3a04"` ]];then    #兆芯E集显
elif [ $card_vendor = "1d17" -a $card_id = "3a04" ]; then    #兆芯E集显
	dpkg -s zhaoxin-linux-graphics-driver &>/dev/null || dpkg -i /usr/local/nfsdrivers/zhaoxin-linux-graphics-driver*_amd64.deb
	lsmod |grep "^zx" || modprobe zx
else
	echo "ZX graphics card is not primary!"
fi

